Protwarbar = LibStub("AceAddon-3.0"):NewAddon("Protwarbar", "AceEvent-3.0",  "AceConsole-3.0", "AceTimer-3.0")

local media = LibStub("LibSharedMedia-3.0")
local PWB = {}

PWB_ICON_COUNT = 2

function Protwarbar:OnInitialize()
	Protwarbar:SetDefaultMedia(media)

	PWB.combat = false
	
	-- 93098 warrior
	-- 84840 druid
	PWB.Vengeance_name = GetSpellInfo(93098)

	PWB.db = LibStub('AceDB-3.0'):New('ProtwarbarDB', self:CreateDefaults(), true)
	PWB.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	PWB.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	PWB.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")

	AceConfig = LibStub("AceConfigDialog-3.0")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Protwarbar", self:CreateOptions())
	AceConfig:AddToBlizOptions("Protwarbar", "Protwarbar")

	Protwarbar:RegisterChatCommand('protwarbar', 'OnCommand')
end

function Protwarbar:OnCommand()
	InterfaceOptionsFrame_OpenToCategory("Protwarbar")
end

function Protwarbar:getPWB()
	return PWB
end

function Protwarbar:RefreshConfig()
	Protwarbar:UpdateStyling()
	Protwarbar:UpdateVisiblity()
end

function Protwarbar:OnEnable()
	local _, playerClass = UnitClass("player")
	
	if playerClass == "WARRIOR" then
		PWB.class = 1
		self:RegisterEvent("UNIT_POWER")
		self:RegisterEvent("UNIT_MAXPOWER")
		self:RegisterEvent("UNIT_AURA");

		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		self:RegisterEvent("PLAYER_REGEN_ENABLED") 		
		
		Protwarbar:BuildGui()
		-- force update the bar every .5 seconds
		self:ScheduleRepeatingTimer("TimerFeedback", 0.5)
	else
		Protwarbar:Print("Protwarbar has been loaded but not enabled. Player is not a warrior.")
	end
end

function Protwarbar:OnDisable()
end

function Protwarbar:TimerFeedback()
	Protwarbar:UpdateRageBar(UnitPower("player"))
	Protwarbar:UpdateIcons()
end

-- start combat
function Protwarbar:PLAYER_REGEN_DISABLED()
	PWB.combat = true
	Protwarbar:UpdateVisiblity()
end

-- end combat
function Protwarbar:PLAYER_REGEN_ENABLED()
	PWB.combat = false
	Protwarbar:UpdateVisiblity()
end


function Protwarbar:UNIT_POWER(arg1, arg2, arg3)
	if (arg2 == "player") then
		Protwarbar:UpdateRageBar(UnitPower("player"))
	end
end

function Protwarbar:UNIT_AURA(eventName, arg1)
	if (arg1 == "player") then
		Protwarbar:UpdateRageBar(UnitPower("player"))
	end
end

function Protwarbar:UNIT_MAXPOWER()
	Protwarbar:UpdateStyling()
end